unit uGUI; { Grundprogramm ft, GUI, mk, 3.5.03 }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  uFtInterface, StdCtrls, ExtCtrls;

type
  TGUI = class(TForm)
    bTreiberStarten: TButton;  bInterfaceStarten: TButton; lTreiber: TLabel;
    lInterface: TLabel; bInterfaceStoppen: TButton; bTreiberStoppen: TButton;
    gbEin: TGroupBox;
    lInput: TLabel; bGetInputs: TButton; lInputX: TLabel; bInputX: TButton;
    lInputY: TLabel; bInputY: TButton; lInputStatusBin: TLabel;
    lE1:TLabel;lE2:TLabel;lE3:TLabel;lE4:TLabel;lE5:TLabel;lE6:TLabel;
    lE7:TLabel;lE8:TLabel;
    l1:TLabel;l2:TLabel;l3:TLabel;l4:TLabel;l5:TLabel;l6:TLabel;
    l7:TLabel;l8:TLabel;
    gbAus: TGroupBox;
    lMotorNr: TLabel; lRichtung: TLabel;  eMotorNr: TEdit; eRichtung: TEdit;
    bSetMotor: TButton; bClearMotors: TButton; lMotor: TLabel;
    bGetMotorStatus: TButton; lMotorStatusBin: TLabel;
    lAllesEin: TLabel; eMS: TEdit; lMs: TLabel;
    Timer1: TTimer;
    lMotorStatus: TLabel;
    eMotorStatus: TEdit;
    bSetMotors: TButton;
    lLampe: TLabel;
    eLampe: TEdit;
    bLAn: TButton;
    bLAus: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure bTreiberStartenClick(Sender: TObject);
    procedure bInterfaceStartenClick(Sender: TObject);
    procedure bInterfaceStoppenClick(Sender: TObject);
    procedure bTreiberStoppenClick(Sender: TObject);
    procedure bSetMotorClick(Sender: TObject);
    procedure bClearMotorsClick(Sender: TObject);
    procedure bGetInputsClick(Sender: TObject);
    procedure eMSChange(Sender: TObject);
    procedure bInputXClick(Sender: TObject);
    procedure bInputYClick(Sender: TObject);
    procedure bGetMotorStatusClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure bSetMotorsClick(Sender: TObject);
    procedure bLAnClick(Sender: TObject);
    procedure bLAusClick(Sender: TObject);
  private
    ftInterface : TftInterface;
  public
    { Public-Deklarationen }
  end;

var
  GUI: TGUI;

implementation
{$R *.DFM}

  function dez2bin(a : byte) : string;
  const
    z : array[0..1] of char = ('0','1');
  var
    s : string;
    r : byte;
  begin
    s := '';
    repeat
      r := a mod 2; a := a div 2; s := z[r] + s;
    until a = 0;
    while length(s) < 8 do s := '0' + s;
    Result := s;
  end;

procedure TGUI.FormCreate(Sender: TObject);
begin
  ftInterface := TftInterface.Create;
  Timer1.Interval := StrToInt(eMS.text);
end;

procedure TGUI.FormDestroy(Sender: TObject);
begin
  ftInterface.Free;
end;

procedure TGUI.bTreiberStartenClick(Sender: TObject);
begin
  if ftInterface.StartDriver
  then lTreiber.caption := 'OK'
  else lTreiber.caption := 'Fehler';
end;

procedure TGUI.bInterfaceStartenClick(Sender: TObject);
begin
  if ftInterface.OpenInterface
  then lInterface.caption := 'OK'
  else lInterface.caption := 'Fehler';
end;

procedure TGUI.bInterfaceStoppenClick(Sender: TObject);
begin
  ftInterface.CloseInterface;
  lInterface.caption := '-----';
end;

procedure TGUI.bTreiberStoppenClick(Sender: TObject);
begin
  ftInterface.StopDriver;
end;

procedure TGUI.bSetMotorClick(Sender: TObject);
var
  nr,richtung : byte;
begin
  nr := StrToInt(eMotorNr.text); richtung := StrToInt(eRichtung.text);
  ftInterface.SetMotor(nr,richtung);
end;

procedure TGUI.bLAnClick(Sender: TObject);
var
  nr : byte;
begin
  nr := StrToInt(eLampe.text);
  ftInterface.SetLamp(nr,1);
end;

procedure TGUI.bLAusClick(Sender: TObject);
var
  nr : byte;
begin
  nr := StrToInt(eLampe.text);
  ftInterface.SetLamp(nr,0);
end;

procedure TGUI.bSetMotorsClick(Sender: TObject);
var
  status : byte;
begin
  status := StrToInt(eMotorStatus.text);
  ftInterface.SetMotors(status);
end;

procedure TGUI.bClearMotorsClick(Sender: TObject);
begin
  ftInterface.ClearMotors;
end;

procedure TGUI.bGetInputsClick(Sender: TObject);
var
  ein : word;
begin
  ein := ftInterface.GetInputs;
  lInput.caption := IntToStr(ein);
  lInputStatusBin.caption := dez2bin(ein);
end;


procedure TGUI.eMSChange(Sender: TObject);
var
  code     : integer;
  interval : word;
begin
  val(eMS.text,interval,code);
  if code > 0 then interval := 0;
  Timer1.Interval := interval;
end;

procedure TGUI.bInputXClick(Sender: TObject);
var
  ein : word;
begin
  ein := ftInterface.GetAnalog(0);
  lInputX.caption := IntToStr(ein);
end;

procedure TGUI.bInputYClick(Sender: TObject);
var
  ein : word;
begin
  ein := ftInterface.GetAnalog(1);
  lInputY.caption := IntToStr(ein);
end;

procedure TGUI.bGetMotorStatusClick(Sender: TObject);
var
  status : word;
begin
  status := ftInterface.GetMotorStatus;
  lMotor.Caption := IntToStr(status);
  lMotorStatusBin.caption := dez2bin(status);
end;

procedure TGUI.Timer1Timer(Sender: TObject);
var
  i    : byte;
begin
  bGetMotorStatusClick(GUI); bGetInputsClick(GUI);
  for i := 1 to 8 do
    if ftInterface.GetInput(i)
    then
      begin
        TLabel(findcomponent('l'+IntToStr(i))).caption := '  true  ';
        TLabel(findcomponent('l'+IntToStr(i))).color := $0000FF00;
      end
    else
      begin
        TLabel(findcomponent('l'+IntToStr(i))).caption := ' false ';
        TLabel(findcomponent('l'+IntToStr(i))).color := clRed;
      end;
  { alternativ:
  if ftInterface.GetInput(1)
  then l1.caption := 'true' else l1.caption := 'false';
  if ftInterface.GetInput(2)
  then l2.caption := 'true' else l2.caption := 'false';
  if ftInterface.GetInput(3)
  then l3.caption := 'true' else l3.caption := 'false';
  if ftInterface.GetInput(4)
  then l4.caption := 'true' else l4.caption := 'false';
  if ftInterface.GetInput(5)
  then l5.caption := 'true' else l5.caption := 'false';
  if ftInterface.GetInput(6)
  then l6.caption := 'true' else l6.caption := 'false';
  if ftInterface.GetInput(7)
  then l7.caption := 'true' else l7.caption := 'false';
  if ftInterface.GetInput(8)
  then l8.caption := 'true' else l8.caption := 'false'; }
end;








end.
